import java.sql.*;
import java.util.Scanner;

/**
 * 
 * @author Tomi
 * 
 */

public class Abkezel {
	private static Connection conn = null;
	private static Statement s = null;
	private static String sqlp = "";
	private int vi = 0;

	// ========== Konstruktor
	public Abkezel() {
	}

	// ========== Konstruktor / Metdusok ==========
	public static int Exec(String sqlp) {
		int out = 0;
		try {
			s = conn.createStatement();
			out = s.executeUpdate(sqlp);
			System.out.println("Vgrehajtott parancs: " + sqlp);
		} catch (Exception e) {
			out = -1;
			System.out.println("Problma: " + e.getMessage());
		}
		return out;
	}

	// =================
	public static void Kapcs(String user, String pswd) {
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			// String url = "jdbc:oracle:thin:@193.6.5.42:1521:info";
			String url = "jdbc:oracle:thin:@localhost:1521:XE";
			conn = DriverManager.getConnection(url, user, pswd);
			System.out.println("Sikeres kapcsolodas");
		} catch (Exception ex) {
			System.err.println(ex.getMessage());
		}
	}

	// =================
	public static void LeKapcs() {
		if (conn != null) {
			try {
				conn.close();
				System.out.println("Sikeres lekapcsolodas");
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	public void StatikusTablaLetrehozas() {
		String sqlp_auto = "create table auto ( rsz char(6) primary key, "
				+ "tipus char(10) not null, szin char(10) default 'feher', "
				+ "evjarat number(4), ar number(8) check(ar>100) ) ";
		String sqlp_tulaj = "create table tulaj(id number(3) primary key, "
				+ " nev char(20) not null, cim char(20), szuldatum date)";
		if (conn != null) {
			try {
				s = conn.createStatement();
				s.executeUpdate(sqlp_auto);
				System.out.println("Aut tbla ltrejtt\n");
				s.executeUpdate(sqlp_tulaj);
				System.out.println("Tulajdonos tbla ltrejtt\n");
				s.close(); // erforrs felszabadtsa
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	public void StatikusTablaModositas() {
		if (conn != null) {
			try {
				String sqlp = "alter table auto add(tulaj_id references tulaj)";
				s = conn.createStatement();
				s.executeUpdate(sqlp);
				System.out.println("Auto tbla mdostva\n");
				s.close();
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	public void StatikusAdatfelvitel() {
		if (conn != null) {
			String sqlp_tul = "insert into tulaj values(1, 'Tth Mt', "
					+ " 'Miskolc', to_date('1980.05.12', 'yyyy.mm.dd'))";

			String[] sqlp = {
					"insert into auto values('aaa211','opel','piros',2014,1650000,1)",
					"insert into auto values ('bbb322','mazda','piros',2016,2800000,1)",
					"insert into auto (rsz, tipus, evjarat, ar) values ('ccc433','ford',2009, 15000000)" };
			try {
				s = conn.createStatement();
				s.executeUpdate(sqlp_tul);
				System.out.println("Tulaj felvve\n");
				s.close();
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
			for (int i = 0; i < sqlp.length; i++) {
				try {
					s = conn.createStatement();
					s.executeUpdate(sqlp[i]);
					System.out.println("Aut felvve\n");
					s.close();
				} catch (Exception ex) {
					System.err.println(ex.getMessage());
				}
			}
		}
	}

	public void DinamikusAdatfelvitel() {
		Scanner sc = new Scanner(System.in);
		PreparedStatement ps = null;

		if (conn != null) {
			// Az SQL parancsban a ? helyre kerlnek a paramterek
			String sqlp = "insert into auto (rsz, tipus, szin, evjarat, ar, tulaj_id)"
					+ "values (?, ?, ?, ?, ?, ?)";
			System.out.println("Krem a rendszmot: ");
			String rsz = sc.next().trim();
			System.out.println("Krem a tpust: ");
			String tipus = sc.next().trim();
			System.out.println("Krem a sznt: ");
			String szin = sc.next().trim();
			System.out.println("Krem az vjratot: ");
			int evjarat = sc.nextInt();
			System.out.println("Krem az rat: ");
			float ar = sc.nextFloat();
			System.out.println("Krem a tulajdonos azonostjt: ");
			int tulaj_id = sc.nextInt();
			try {
				ps = conn.prepareStatement(sqlp);
				ps.setString(1, rsz);
				ps.setString(2, tipus);
				ps.setString(3, szin);
				ps.setInt(4, evjarat);
				ps.setFloat(5, ar);
				ps.setInt(6, tulaj_id);
				ps.executeUpdate();
				ps.close();
				System.out.println("Aut felvve\n");
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	public void StatikusAdattorles() {
		Scanner sc = new Scanner(System.in);

		System.out.println("Trlend aut rendszma: ");
		String rsz = sc.next();
		String sqlp = "delete from auto where rsz like '" + rsz + "'";
		if (conn != null) {
			try {
				s = conn.createStatement();
				s.executeUpdate(sqlp);
				s.close();
				System.out.println(rsz + " rendszm aut trlve\n");
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	public void StatikusLekerdezes() {
		ResultSet rs = null;

		if (conn != null) {
			String sqlp = "select * from auto";
			System.out.println("Rendszm Tpus Szn vjrat r Tulaj");
			System.out
					.println("-------------------------------------------------");
			try {
				s = conn.createStatement();
				s.executeQuery(sqlp);
				rs = s.getResultSet();
				while (rs.next()) {
					// A get metdusoknak a megfelel tpus tblamezket kell
					// megadni
					String rsz = rs.getString("rsz");
					String tipus = rs.getString("tipus");
					String szin = rs.getString("szin");
					int evjarat = rs.getInt("evjarat");
					int ar = rs.getInt("ar");
					int tulaj_id = rs.getInt("tulaj_id");
					System.out.println(rsz + "\t\t" + tipus + "\t" + szin
							+ "\t" + evjarat + "\t" + ar + "\t" + tulaj_id);
				}
				rs.close();
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	public void ModosithatoKurzor() {
		Scanner sc = new Scanner(System.in);
		Statement s = null;
		ResultSet rs = null;

		System.out.println("Szn: ");
		String szin = sc.next().trim();
		String sqlp = "select ar from auto where szin = '" + szin + "'";
		if (conn != null) {
			try {
				s = conn.createStatement(ResultSet.TYPE_FORWARD_ONLY,
						ResultSet.CONCUR_UPDATABLE);
				rs = s.executeQuery(sqlp);
				while (rs.next()) {
					int regiar = rs.getInt("ar");
					rs.updateInt("ar", (regiar * 2));
					rs.updateRow();
				}
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	public void DinamikusModositas() {
		Scanner sc = new Scanner(System.in);
		PreparedStatement ps = null;

		if (conn != null) {
			String sqlp = "update auto set ar=ar-?";
			System.out.println("Mennyivel cskkentsk az rat? ");
			int arcsokk = sc.nextInt();
			try {
				conn.setAutoCommit(false);
				try {
					ps = conn.prepareStatement(sqlp);
					ps.setInt(1, arcsokk);
					ps.executeUpdate();
					conn.commit();
					System.out.println("Mdosts megtrtnt\n");
				} catch (Exception e) {
					System.err.println(e.getMessage());
					conn.rollback();
					System.out.println("Mdosts visszavonva\n");
				}
				conn.setAutoCommit(true);
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	public void OutEljarasHivas() {
		Scanner sc = new Scanner(System.in);
		CallableStatement cs = null;

		if (conn != null) {
			try {
				String sqlp = "create or replace procedure atlagar "
						+ "(sz IN char, atl OUT number) is " + "begin "
						+ "select avg(ar) into atl from auto where szin=sz; "
						+ "end;";
				System.out.println("Szn: ");
				String szin = sc.next();
				s = conn.createStatement();
				s.executeUpdate(sqlp);
				System.out.println("Eljrs ltrejtt\n");
				cs = conn.prepareCall("{call atlagar(?, ?)}");
				cs.setString(1, szin);
				cs.registerOutParameter(2, java.sql.Types.FLOAT);
				cs.execute();
				float atlag = cs.getFloat(2);
				System.out.println(szin + " autk tlagra: " + atlag + "\n");
			} catch (Exception ex) {
				System.err.println(ex.getMessage());
			}
		}
	}

	// ========== Metdusok / Fprogram ==========
	public static void main(String args[]) {
		Abkezel abk = new Abkezel();

		Kapcs("system", "Jelszo");

		// sqlp = "drop table tulaj";
		// sqlp = "drop table auto";
		// int valami = Exec(sqlp);
		
		

		// abk.StatikusTablaLetrehozas();
		// abk.StatikusTablaModositas();
		// abk.StatikusAdatfelvitel();

		// abk.DinamikusAdatfelvitel();
		// abk.StatikusAdattorles();
		// abk.StatikusLekerdezes();
		// abk.ModosithatoKurzor();
		// abk.StatikusLekerdezes();
		// abk.DinamikusModositas();
		// abk.StatikusLekerdezes();
		// abk.OutEljarasHivas();
		LeKapcs();
	}
}